'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.memoizedPipe = exports.memoizedFlow = exports.memoizedCompose = exports.memoizedFlowRight = undefined;

var _memoize = require('./memoize');

var applyFunctions = function applyFunctions(value, fn) {
  return Object.assign({}, value, fn(value) || {});
};

var memoizedFlow = function memoizedFlow(functions) {
  var flow = functions.map(_memoize.memoize);
  return function (input) {
    return flow.reduce(applyFunctions, input);
  };
};

var memoizedFlowRight = function memoizedFlowRight(functions) {
  return memoizedFlow(Array.from(functions).reverse());
};

// aliases
var memoizedPipe = memoizedFlow;
var memoizedCompose = memoizedFlowRight;

exports.memoizedFlowRight = memoizedFlowRight;
exports.memoizedCompose = memoizedCompose;
exports.memoizedFlow = memoizedFlow;
exports.memoizedPipe = memoizedPipe;